import { styled } from "solid-styled-components";
import { Show, createSignal, onMount } from "solid-js";
import { vector2d } from "./vector";

import Player from "./objects/player";

const StageContainer = styled("div")`
  width: 100vw;
  height: 100vh;

  position: relative;

  overflow: hidden;
`;

export default function Stage() {
  let container: HTMLDivElement = document.createElement("div");

  let playerPosition = new vector2d(0, 0);

  let [ready, setReady] = createSignal(false);

  function movePlayer(element: HTMLDivElement) {
    playerPosition = new vector2d(
      element.clientWidth / 2,
      element.clientHeight / 2
    );

    setReady(true);
  }

  onMount(() => movePlayer(container));

  return (
    <StageContainer ref={container}>
      <Show when={ready()}>
        <Player size={64} position={playerPosition} />
      </Show>
    </StageContainer>
  );
}
